﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Timers;
using System.Windows.Forms;


//调试中如果提示找不到DLL文件，请将工程目录下的MPS Driver.dll和MPS Driver _x64.dll拷贝至Bin目录下的Debug和Release文件夹下
namespace MPS_HDxxxx
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = comboBox1.Items.IndexOf("64000");
            comboBox2.SelectedIndex = comboBox2.Items.IndexOf("Unused");
            CheckForIllegalCrossThreadCalls = false;
        }


        private bool DataIn(int AcquisitionSampleRate = 64000, double AcquisitionTimeLength = 1000, int DIO_Mode = 0)       //数据采集
        {

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_OpenDevice", CallingConvention = CallingConvention.Cdecl)]                            //打开设备函数的声明
            static extern int MPS_OpenDevice(int DeviceNumber);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_CloseDevice", CallingConvention = CallingConvention.Cdecl)]                           //关闭设备函数的声明
            static extern int MPS_CloseDevice(int DeviceHandle);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_Configure", CallingConvention = CallingConvention.Cdecl)]                             //设置设备参数函数的声明
            static extern int MPS_Configure(int SampleRate, int DIOMode, int DeviceHandle);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_Start", CallingConvention = CallingConvention.Cdecl)]                                 //启动设备采集函数的声明
            static extern int MPS_Start(int DeviceHandle);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_Stop", CallingConvention = CallingConvention.Cdecl)]                                  //停止设备采集函数的声明
            static extern int MPS_Stop(int DeviceHandle);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_DataIn", CallingConvention = CallingConvention.Cdecl)]                                //读取数据函数的声明
            static extern int MPS_DataIn(ref Int32 DataArray, int SampleNumber, int DeviceHandle);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_TimeOut", CallingConvention = CallingConvention.Cdecl)]                               //设置读数超时函数的声明
            static extern int MPS_TimeOut(int TimeOut_ms, int DeviceHandle);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_GetDeviceDescriptor", CallingConvention = CallingConvention.Cdecl)]                  //获取设备型号信息函数的声明
            static extern int MPS_GetDeviceDescriptor(ref byte DescriptorBuffer, int BufferSize, int DeviceHandle);




            /*函数声明结束*/


            [DllImport("user32.dll", EntryPoint = "MessageBoxA")]                                       //系统消息通知函数的声明
            static extern int MsgBox(int hWnd, string msg, string caption, int type);


            /*采集数据*/
            //定义变量
            int Flag;                                           //函数执行成功标志
            int DeviceNumber = 0;                               //操作系统分配的设备硬件序号
            int ChannalNumber = 4;                              //通道数目，MPS-HD2404为4通道，MPS-HD2408为8通道，MPS-HD2416为16通道
            int DeviceHandle = 0;                               //设备句柄
            int SampleRate = AcquisitionSampleRate;             //采样率，取值1000、2000、4000、8000、16000、32000、64000或128000   
            int DIOMode = DIO_Mode;                             //DIO模式，取值0：闲置；1：输出5V；2：外启动模式
            double TimeLength = AcquisitionTimeLength;          //保存采集到的数据的时间长度
            double VoltageRange = 5.16;                         //量程参数，MPS-HD2404、MPS-2408、MPS-HD2416、MPS-HD1608、MPS-HD1616等量程为5.16V；MPS-HD1604量程为5.2V；MPS-HD1802量程为5.3V；

            DeviceHandle = MPS_OpenDevice(DeviceNumber);        //先打开设备
            if (DeviceHandle == -1)                             //若打开失败，报错并返回
            {
                MsgBox(0, "OpenDeviceError", "Error", 0x30);
                return false;            
            }


            //获取设备的型号，进而判定通道个数
            byte[] DeviceDescriptor = new byte[64];                 //保存设备型号信息的缓存数组
            Flag = MPS_GetDeviceDescriptor(ref DeviceDescriptor[0], 64, DeviceHandle);//获取设备型号

            if (DeviceDescriptor[9] == '2') ChannalNumber = 2;        //判断通道个数，根据型号的最后一位来判断通道个数，最后一位为2时通道数为2，最后一位为4时通道数为4，最后一位为8时通道数为8，最后一位为6（即16）时通道数为16；例如型号为MPS-HD2404，最后一位为4，此时通道数为4；
            else if (DeviceDescriptor[9] == '4') ChannalNumber = 4;
            else if (DeviceDescriptor[9] == '8') ChannalNumber = 8;   
            else if (DeviceDescriptor[9] == '6') ChannalNumber = 16;  

            VoltageRange = 5.16;                                      //设定量程参数，MPS-HD2404、MPS-2408、MPS-HD2416、MPS-HD1608、MPS-HD1616等量程为5.16V；MPS-HD1604量程为5.2V；MPS-HD2402和MPS-HD1802量程为5.3V；


            //设置参数，设置超时，启动采集
            Flag = MPS_Configure(SampleRate, DIOMode, DeviceHandle);//设置采样率和复用IO口
            MPS_TimeOut(5000, DeviceHandle);                    //设置等待超时为5s，如果用于外启动超时，可根据情况修改设置值


            if (DIOMode != 2) Flag = MPS_Start(DeviceHandle);   //启动设备采集；外部启动模式时不通过调用MPS_Start来启动


            //以下为循环调用采集函数的方式来读取数据
            Int32[] DataBuffer = new Int32[1024 * 16];           //用于保存读出的原始整形数据的缓存数组，请务必注意此变量一定定义为32位整形数
            double[,] Voltage = new double[16, 10240000];        //用于保存经过计算的电压的数据数组Voltage,定义的大小必须足够保存TimeLength对应的数据长度
            int Counter = 0;                                     //数据点数的计数

            while (true)
            {

                Flag = MPS_DataIn(ref DataBuffer[0], 1024 * ChannalNumber, DeviceHandle);  //读取数据，每次每个通道读取1024点

                if (Flag != 0)                                  //如果采集成功
                {
                    for (int i = 0; i < 1024; i++)              //数据处理，计算电压值；4个通道的数据在缓存中循环排列；电压值 = (采集值/(65536*128))*量程
                    {
                        if (Counter >= SampleRate * TimeLength) break;                                      //如果样点达到SampleNumberPerCH，则跳出for循环
                        for (int j = 0; j < ChannalNumber; j++)
                        {
                            Voltage[j, Counter] = ((double)DataBuffer[i * ChannalNumber + j] / 8388608) * VoltageRange;         //转换为电压
                        }
                        Counter++;
                    }
                }
                else
                {
                    MsgBox(0, "MPS_DataInError", "Error", 0x30);//如果采集失败报错并跳出while循环
                    return false;
                }

                if (Counter >= SampleRate * TimeLength)         //如果读出全部数据，跳出while循环。此处也可添加其他跳出循环的条件
                {
                    break;
                }
            }

            //至此采集过程完成，后面要停止硬件采集并关闭设备
            Flag = MPS_Stop(DeviceHandle);                      //采集任务结束后停止采集
            Thread.Sleep(5);
            Flag = MPS_CloseDevice(DeviceHandle);               //最后关闭设备

            if (Counter == SampleRate * TimeLength)             //判断GetVoltageData函数是否已经获取到了指定的SampleNumberPerCH个样点数
            {
                for (int i = 0; i < 16; i++)                    //显示与通道个数对应的曲线
                {
                    if (i < ChannalNumber)
                    {
                        this.chart1.Series[i].Points.Clear();
                        this.chart1.Series[i].Enabled = true;
                    }
                    else
                    {
                        this.chart1.Series[i].Points.Clear();
                        this.chart1.Series[i].Enabled = false;
                    }
                }

                for (int i = 0; i < ChannalNumber; i++)         //绘制曲线
                {
                    int PointsMumberMax = 1000;                 //送入波形图的显示点数上限，点数越多CPU资源占用越大
                    int PointsMumber = Counter;
                    int interval = 1;
                    while (true)                                //确定送入波形图的显示点数
                    {
                        if(Counter % interval  == 0)PointsMumber = (int)Counter / (int)interval;
                        if (PointsMumber <= PointsMumberMax) break;
                        interval++;
                    }
                    for (int j = 0; j < PointsMumber; j++)      //显示
                    {
                        this.chart1.Series[i].Points.AddXY(j * interval * TimeLength / Counter, Voltage[i, j * interval]);
                    }
                }
            }
            return true;

        }




        private void GetDeviceInformation()                     //获取设备硬件信息
        {

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_OpenDevice", CallingConvention = CallingConvention.Cdecl)]                            //打开设备函数的声明
            static extern int MPS_OpenDevice(int DeviceNumber);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_CloseDevice", CallingConvention = CallingConvention.Cdecl)]                           //关闭设备函数的声明
            static extern int MPS_CloseDevice(int DeviceHandle);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_GetDeviceInformation", CallingConvention = CallingConvention.Cdecl)]                  //获取设备型号信息函数的声明
            static extern int MPS_GetDeviceInformation(ref byte DescriptorBuffer, int BufferSize, int DeviceHandle);


            /*函数声明结束*/


            [DllImport("user32.dll", EntryPoint = "MessageBoxA")]                                       //系统消息通知函数的声明
            static extern int MsgBox(int hWnd, string msg, string caption, int type);


            /*采集数据*/
            //定义变量
            int Flag;                                           //函数执行成功标志
            int DeviceNumber = 0;                               //操作系统分配的设备硬件序号
            int DeviceHandle = 0;                               //设备句柄

            DeviceHandle = MPS_OpenDevice(DeviceNumber);        //先打开设备
            if (DeviceHandle == -1)                             //若打开失败，报错并返回
            {
                MsgBox(0, "OpenDeviceError", "Error", 0x30);
                return;
            }

            //获取设备的硬件信息
            byte[] DeviceInformation = new byte[2048];          //保存设备硬件信息的缓存数组
            Flag = MPS_GetDeviceInformation(ref DeviceInformation[0], 2048, DeviceHandle);//获取设备硬件信息
            Flag = MPS_CloseDevice(DeviceHandle);               //关闭设备
            if (Flag == 0)
            {
                MsgBox(0, "MPS_GetDeviceInformation", "Error", 0x30);//如果获取信息失败报错
            }
            else
            {
                string Inf = System.Text.Encoding.UTF8.GetString(DeviceInformation);
                MsgBox(0, Inf, "DeviceInformation", 0x30);      //显示硬件信息
            }

        }



        private void SetUserInformation()                       //写入用户自定义信息
        {

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_OpenDevice", CallingConvention = CallingConvention.Cdecl)]                            //打开设备函数的声明
            static extern int MPS_OpenDevice(int DeviceNumber);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_CloseDevice", CallingConvention = CallingConvention.Cdecl)]                           //关闭设备函数的声明
            static extern int MPS_CloseDevice(int DeviceHandle);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_GetDeviceInformation", CallingConvention = CallingConvention.Cdecl)]                  //获取设备型号信息函数的声明
            static extern int MPS_GetDeviceInformation(ref byte DescriptorBuffer, int BufferSize, int DeviceHandle);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_SetUserInformation", CallingConvention = CallingConvention.Cdecl)]                  //获取设备型号信息函数的声明
            static extern int MPS_SetUserInformation(ref byte UserInformation, int BufferSize, int DeviceHandle);


            /*函数声明结束*/


            [DllImport("user32.dll", EntryPoint = "MessageBoxA")]                                       //系统消息通知函数的声明
            static extern int MsgBox(int hWnd, string msg, string caption, int type);


            /*采集数据*/
            //定义变量
            int Flag;                                           //函数执行成功标志
            int DeviceNumber = 0;                               //操作系统分配的设备硬件序号
            int DeviceHandle = 0;                               //设备句柄

            DeviceHandle = MPS_OpenDevice(DeviceNumber);        //先打开设备
            if (DeviceHandle == -1)                             //若打开失败，报错并返回
            {
                MsgBox(0, "OpenDeviceError", "Error", 0x30);
                return;
            }

            //写入用户自定义信息
            byte[] UserInformation = new byte[500];             //保存用户自定义信息的缓存数组
            UserInformation = System.Text.Encoding.UTF8.GetBytes("This is a C# test(" + DateTime.Now.ToString("yyyyMMddhhmmss") + ").");    //写入一组字符串并叠加当前时间
            Flag = MPS_SetUserInformation(ref UserInformation[0], 500, DeviceHandle);//写入自定义信息

            byte[] DeviceInformation = new byte[2048];          
            Flag = MPS_GetDeviceInformation(ref DeviceInformation[0], 2048, DeviceHandle);//读取一次设备硬件信息

            Flag = MPS_CloseDevice(DeviceHandle);               //关闭设备
            if (Flag == 0)
            {
                MsgBox(0, "MPS_SetUserInformation", "Error", 0x30);//如果获取信息失败报错
            }
            else
            {
                string Inf = System.Text.Encoding.UTF8.GetString(DeviceInformation);
                MsgBox(0, Inf, "DeviceInformation", 0x30);      //显示硬件信息
            }
        }



        private void ResetHardware()                       //重置复位设备硬件，用于设备异常时复位
        {
            [DllImport("MPS Driver.dll", EntryPoint = "MPS_OpenDevice", CallingConvention = CallingConvention.Cdecl)]                            //打开设备函数的声明
            static extern int MPS_OpenDevice(int DeviceNumber);

            [DllImport("MPS Driver.dll", EntryPoint = "MPS_ResetDevice", CallingConvention = CallingConvention.Cdecl)]                           //设备硬件重置函数的声明
            static extern int MPS_ResetDevice(int DeviceHandle);

            [DllImport("user32.dll", EntryPoint = "MessageBoxA")]                                       //系统消息通知函数的声明
            static extern int MsgBox(int hWnd, string msg, string caption, int type);

            //定义变量
            int Flag;                                           //函数执行成功标志
            int DeviceNumber = 0;                               //操作系统分配的设备硬件序号
            int DeviceHandle = 0;                               //设备句柄

            DeviceHandle = MPS_OpenDevice(DeviceNumber);        //先打开设备
            if (DeviceHandle == -1)                             //若打开失败，报错并返回
            {
                MsgBox(0, "OpenDeviceError", "Error", 0x30);
                return;
            }
            else Flag = MPS_ResetDevice(DeviceHandle);          //重启设备
        }


        private void timer1_Tick(object sender, EventArgs e)
        {
            int SampleRate = int.Parse(comboBox1.SelectedItem.ToString());  //从界面获取采样率
            double TimeLength = (double)this.AcquisitionTime.Value / 1000;  //从界面获取采杨时间
            int DIOMode = comboBox2.SelectedIndex;                          //从界面获取DIO模式
            bool t = timer1.Enabled;                                        //临时关闭定时器
            timer1.Enabled = false;
            bool Flag = false;
            Flag = DataIn(SampleRate, TimeLength, DIOMode);                 //按采样率和采样时间进行采集
            if(Flag) timer1.Enabled = t;                                    //如果采集成功，恢复定时器
        }


        private void Button_Acquisition_Click(object sender, EventArgs e)
        {
            if(timer1.Enabled == true)timer1.Enabled = false;               //点击按钮开启/关闭定时器
            else
            {
                timer1.Enabled = true;
                timer1.Interval = 10;
                timer1.Start();
            }
        }

        private void GetInf_Click(object sender, EventArgs e)
        {
            GetDeviceInformation();                                         //读取硬件信息
        }

        private void SetUserInf_Click(object sender, EventArgs e)
        {
            SetUserInformation();                                           //写入用户信息
        }

        private void ResetDevice_Click(object sender, EventArgs e)
        {
            ResetHardware();                                                //重置设备硬件
        }
    }
}

